%define unstable 1

Name:       piklab
Version:    0.16.1
Release:    2%{?dist}
Summary:    Development environment for applications based on PIC & dsPIC microcontrollers
Summary(fr):IDE pour applications à base de microcontrôleurs PIC et de dsPIC

Group:      Development/Tools
License:    GPLv2+
URL:        http://piklab.sourceforge.net

Source:     http://switch.dl.sourceforge.net/piklab/%{name}-%{version}.tar.bz2
Source1:    %{name}-026-microchip.rules
Source2:    %{name}-icd2.perms
Source3:    %{name}-pickit1.perms
Source4:    %{name}-pickit2.perms
Source5:    %{name}-README.Fedora
Source6:    %{name}-LISEZMOI.Fedora
Source7:    %{name}-10-microchip.fdi

Patch0:     %{name}-%{version}-desktop-fr.patch
Patch1:     %{name}-0.15.12-use-fedora-docdir.patch
Patch2:     %{name}-%{version}-fix-compilation-with-kde4-r2952.patch
Patch3:     %{name}-%{version}-fix-kate-part-path-r2936.patch
%if 0%{?rhel}
Patch4:     %{name}-%{version}-api-kde4.3.patch
Patch5:     %{name}-%{version}-flag-no-access-control.patch
%endif

Patch10:    %{name}-%{version}-report-error-executable-not-found.rev2928.patch
Patch11:    %{name}-%{version}-dont-power-target.rev2930.patch
Patch12:    %{name}-%{version}-retry-icd2-serial-10-times.rev2931.patch
Patch13:    %{name}-%{version}-fix-crash.rev2940.patch
Patch14:    %{name}-%{version}-fix-hang-with-stop-command-in-clp.rev2944.patch
Patch15:    %{name}-%{version}-new-sdcc-syntax.rev2953.patch
Patch16:    %{name}-%{version}-misc-fixes.rev2956.patch


BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  desktop-file-utils, kdelibs4-devel, libusb-devel, readline-devel
BuildRequires:  cmake
# Needed for FC6
BuildRequires:  ncurses-devel, gettext

Requires: electronics-menu

%if 0%{?fedora}
Requires: kate-part, kde-runtime, oxygen-icon-theme
%endif

%description
Piklab is a graphic development environment for PIC and dsPIC microcontrollers.
It interfaces with various toolchains for compiling and assembling and it
supports several Microchip and direct programmers.

WARNING: Administrator have to see the README.Fedora file locate
in the %{_docdir}/%{name}-%{version} directory
to complete full feature installation.

%description -l fr
Piklab est un environnement de développement graphique pour les
microcontrôleurs PIC et dsPIC. Il s'interface avec diverses chaînes d'outils
pour la compilation et l'assemblage et gère plusieurs programmateurs y compris
ceux de Microchip.

ATTENTION : l'installateur du paquetage doit lire le fichier LISEZMOI.Fedora,
situé dans le répertoire %{_docdir}/%{name}-%{version}, afin de voir
comment finir l'installation.

%prep
%setup -q

%patch0 -p0 -b .desktop-fr
%patch1 -p0 -b .use-fedora-docdir
%patch2 -p0 -b .fix-compilation-with-kde4
%patch3 -p0 -b .fix-kate-part-path
%if 0%{?rhel}
%patch4 -p0 -b .compilation-kde4.3
%patch5 -p0 -b .no-access-control-compilation-flag
%endif

%patch10 -p0 -b .report-error
%patch11 -p0 -b .dont-power-target
%patch12 -p0 -b .retry-icd2-serial
%patch13 -p0 -b .fix-crash
%patch14 -p0 -b .fix-hang
%patch15 -p0 -b .new-sdcc-syntax
%patch16 -p0 -b .misc-fixes

%{__install} -pm 644 %{SOURCE5} README.Fedora
%{__install} -pm 644 %{SOURCE6} LISEZMOI.Fedora


%build
%cmake_kde4

%{__make} %{?_smp_mflags}


%install
%{__rm} -rf %{buildroot}
%{__make} DESTDIR=%{buildroot} install

desktop-file-install --vendor=fedora \
  --dir %{buildroot}%{_datadir}/applications \
  --remove-category "Development" \
  --remove-category "IDE" \
  --delete-original \
  %{buildroot}/usr/share/applications/kde4/piklab.desktop

%{__install} -d %{buildroot}%{_sysconfdir}/udev/rules.d/
%{__install} -d %{buildroot}%{_sysconfdir}/security/console.perms.d/
%{__install} -d %{buildroot}%{_datadir}/hal/fdi/policy/10osvendor/
%{__install} -pm 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/udev/rules.d/026-microchip.rules
%{__install} -pm 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/security/console.perms.d/icd2.perms
%{__install} -pm 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/security/console.perms.d/pickit1.perms
%{__install} -pm 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/security/console.perms.d/pickit2.perms
%{__install} -pm 644 %{SOURCE7} %{buildroot}%{_datadir}/hal/fdi/policy/10osvendor/10-microchip.fdi


# Fix absolute symlink
%{__rm} -f %{buildroot}%{_docdir}/HTML/*/%{name}/common
BKP_PWD=`pwd`
cd %{buildroot}%{_docdir}/HTML/en/%{name}/
ln -s ../common .
cd $BKP_PWD

%find_lang %{name}


%clean
%{__rm} -rf %{buildroot}


%post
touch --no-create %{_datadir}/icons/hicolor || :
update-desktop-database %{_datadir}/applications > /dev/null 2>&1 || :
update-mime-database %{_datadir}/mime &> /dev/null || :


%postun
if [ $1 -eq 0 ]
then
  touch --no-create %{_datadir}/icons/hicolor || :
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi
update-desktop-database %{_datadir}/applications > /dev/null 2>&1 || :
update-mime-database %{_datadir}/mime &> /dev/null || :


%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%files -f %{name}.lang
%defattr(-, root, root)
%doc Changelog COPYING README TODO README.Fedora LISEZMOI.Fedora
%{_bindir}/*
%{_datadir}/applications/fedora-%{name}.desktop
%{_kde4_appsdir}/%{name}/
%{_kde4_appsdir}/katepart/syntax/*
%attr(644, -, -) %{_datadir}/mime/packages/*
%{_datadir}/doc/HTML/en/%{name}/
%{_datadir}/icons/hicolor/*/*/*.png
%{_mandir}/man1/*

%{_datadir}/hal/fdi/policy/10osvendor/10-microchip.fdi
%config(noreplace) %{_sysconfdir}/udev/rules.d/026-microchip.rules
%config(noreplace) %{_sysconfdir}/security/console.perms.d/*.perms

%changelog
* Thu Sep 20 2012  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.16.1-2
- Report an error when executable is not found (rev2928)
- Don't power target with ICD2 if device nominal VDD is not 5V (rev2930)
- Retry 10 times when setting serial port mode for ICD2 (rev2931-2932)
- Fix crash when changind watched variable value (rev2940)
- Fix hang with stop command in interactive command line programmer (rev2944)
- Fix sdcc generator for latest sdcc (since 3.1.0) (rev2953)
- Miscellaneous fixes (rev2956)

* Fri Sep 14 2012  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.16.1-1
- Added OS conditional build
- Patch to use kde4.3 api instead of newest (Kevin Kofler is a guru!)

* Thu Sep 13 2012  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.16.1-0
- New upstream version (KDE4 port)
- Updated patch 0
- Removed patch 1 (no more x-desktop)
- Remove patches 3, 4 and 5 (fixed upstream)
- Added patch to fix build with KDE4 (r2952)
- Added patch to fix kate-part files path (r2936)
- Used kde4_appsdir macro
- Fixed file permissions
- Added some required runtime dependencies
- Thanks to Branko, Kevin Kofler and Rex Dieter

* Thu Mar 15 2012  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.12-1
- New upstream version
- Add PolicyKit support

* Wed Feb  1 2012  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.10-3
- Remove stupid previous idea

* Mon Jan 30 2012  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.10-2
- Change default sdcc unix name to match the sdcc Fedora package

* Sat Jan 30 2011  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.10-1
  - New upstream version
  - Fix rules (BZ #594932), patch from David Dillow

* Sat May 22 2010  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.8-3
  - Change name of likeback icons to fix BZ #594932

* Thu May 20 2010  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.8-2
  - Fix makefile http://fedoraproject.org/wiki/UnderstandingDSOLinkChange

* Tue May  4 2010  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.8-1
  - New upstream version
  - Remove patch10 that are no more needed
  - piklab use now cmake
  - Patch to add icd2 programmer support for 18F88X, 12F609/615, 16F610
  - Patch to remove doc installation also installed in docdir

* Mon Mar 15 2010  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.7-2
  - Add a patch to fix a bug that didn't allow to find gpsim

* Wed Mar 10 2010  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.7-1
  - New upstream version
  - Remove patches 2 & 3 that are no more needed

* Sun Feb  7 2010  Alain Portal <alain.portal[AT]univ-montp2[DOT]fr> 0.15.3-5
  - Fix typo: this is Piklab, not Pikdev
  - New desktop-fr patch
  - Update and apply patch2
  - Add update-mime-database in scriptlets
  - Update gtk-update-icon-cache use in scriptlets
  - Add %%posttrans scriptlet

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.15.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.15.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Nov 10 2008 Thibault North <tnorth [AT] fedoraproject DOT org> - 0.15.3-2
  - Fix %%patch3

* Sat Jun 07 2008 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> - 0.15.3-1
  - New upstream release
  - compiling with Qt 3.3

* Fri Jun 06 2008  Aanjhan Ranganathan <aanjhan [AT] tuxmaniac[DOT]com> 0.15.0-2
  - Fixed build issues with Fedora 9
  - Changed build dep from kdelibs-devel to kdelibs3-devel

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.15.0-2
  - Autorebuild for GCC 4.3

* Mon Oct 22 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.15.0-1
  - New upstream version
  - Update %%patch2

* Sun Sep 02 2007 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> - 0.14.5-2
  - fixing desktop file

* Fri Aug 17 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.14.5-1
  - New upstream version
  - %%patch0 is no more needed
  - Update %%patch2
  - Add man pages
  - New Licence GPLv2+

* Sat Jul 21 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.14.2-4
  - Remove QT from Categories

* Sat Jul 21 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.14.2-3
  - Update Source1 to change the usb udev rules. Fix #249029

* Sun Apr 15 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.14.2-2
  - Add patch to complete french translation

* Sat Apr 14 2007 Chitlesh Goorah <chitlesh [AT] fedoraproject DOT org> - 0.14.2-1
  - New upstream release

* Mon Mar 12 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.14.1-1
  - New upstream version
  - %%patch2 is no more needed

* Fri Mar  9 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.14.0-2
  - Update {LISEZMOI,README}.Fedora files to tell administrator to modify
    PATH in /etc/profile for users to be able to use SDCC Compiler

* Wed Mar  7 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.14.0-1
  - New upstream version
  - Update %%patch2

* Mon Feb 26 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.13.3-2.fc6.1
  - Really add patch

* Mon Feb 26 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.13.3-2
  - Add patch to complete french translation

* Mon Feb 12 2007  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.13.3-1
  - New upstream version

* Wed Nov 15 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.12.2-3
  - Fix EVR.

* Tue Nov 14 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.12.2-1
  - New upstream version

* Mon Oct 16 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.12.1-1
  - New upstream version

* Mon Oct  2 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.12.0-3
  - Upstream rebuilt tarball :-(

* Mon Oct  2 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.12.0-2
  - Add BR gettext since there is now translation

* Mon Oct  2 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.12.0-1
  - New upstream version
  - Remove patch1 that is no more needed

* Fri Sep 29 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.11.3-5
  - Fix typo in pickit2.perms

* Fri Sep 29 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.11.3-4
  - Fix typo for installing pickit2.perms
  - Add Application category in desktop file
  - Fix symlink: english is the only language where common directory is in
  LANG directory while for other, common is in LANG/docs directory

* Fri Sep 29 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.11.3-3
  - Add doc about how to complete full feature installation
  - Fix typo on security pathname
  - Short summary
  - Add BR ncurses-devel for FC6

* Thu Sep 28 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.11.3-2
  - Remove duplicate BR
  - Fix files permissions
  - Improve download URL
  - Don't mis space and tab

* Wed Sep 27 2006  Alain Portal <aportal[AT]univ-montp2[DOT]fr> 0.11.3-1
  - Initial Fedora package
  - Fedorize the Mandriva spec file from Nicolas Hadacek
